<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="initial-scale=1.0, user-scalable=no">
    <meta charset="utf-8">
    <title>Rainy Rain</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
    <style>
      /* Always set the map height explicitly to define the size of the div
       * element that contains the map. */
      #map {
        margin-top: 5%;
        /*margin-left: 5%%*/
        height: 80%;
        width: 90%;
      }
      /* Optional: Makes the sample page fill the window. */
      html, body {
        height: 100%;
        margin-left: 5%;
        padding: 0;
      }
      .container {
        margin-left: -3%;
      }
    </style>
  </head>
  <body>
    <div id="map"></div>
    <button id = "calculateArea" onclick="calcArea()">Area</button>
    <p id = "area"></p>
    <div class="container">
      <h2>Month and Rain</h2>
  <table class="table">
    <thead>
      <tr>
        <th>Month</th>
        <th>January</th>
        <th>February</th>
        <th>March</th>
        <th>April</th>
        <th>May</th>
        <th>June</th>
        <th>July</th>
        <th>August</th>
        <th>September</th>
        <th>October</th>
      </tr>
    </thead>
    <tbody>
      <tr>

        <td>Rain (mm)</td>
        <td id = "jan"><!-- 15 --></td>
        <td id = "feb"><!-- 15 --></td>
        <td id = "mar"><!-- 30 --></td>
        <td id = "apr"><!-- 55 --></td>
        <td id = "may"><!-- 115 --></td>
        <td id= "jun"><!-- 255 --></td>
        <td id = "jul"><!-- 360 --></td>
        <td id = "aug"><!-- 315 --></td>
        <td id = "sep"><!-- 185 --></td>
        <td id = "oct"><!-- 60 --></td>
      </tr>
      <tr>
        <td>Volume (liter)</td>
        <td id = "vol1"></td>
        <td id = "vol2"></td>
        <td id = "vol3"></td>
        <td id = "vol4"></td>
        <td id = "vol5"></td>
        <td id = "vol6"></td>
        <td id = "vol7"></td>
        <td id = "vol8"></td>
        <td id = "vol9"></td>
        <td id = "vol10"></td>

      </tr>
    </tbody>
  </table>
</div>
<h2 id = "generalReport"></h2>
<div id = "overallReport">
  <p id = "totalArea"></p>
  <p id = "totalVolume"></p>
  <p id = "waterConsumption"></p>
  <p id = "totalPopulation"></p>
  <p id = "waterSupplied"></p>
</div>
    <div id="chartContainer" style="height: 300px; width: 90%"></div>
    </body>
</html>
    <script>

      var poly;
      var map;
      var spherical;
      var position = [];
      var latlang = [];
      var area;
      var reportData = [];
      // var months = ["Jan", "Feb", "Mar", "Feb", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct"];

      function initMap() {

         var geocoder = new google.maps.Geocoder();
        var infowindow = new google.maps.InfoWindow;

        map = new google.maps.Map(document.getElementById('map'), {
          zoom: 17,
          center: {lat: 27.70787344783713, lng: 85.31552585583626}  // Center the map on Chicago, USA.
        });

        poly = new google.maps.Polyline({
          strokeColor: '#000000',
          strokeOpacity: 1.0,
          strokeWeight: 3
        });
        poly.setMap(map);

        // Add a listener for the click event
        map.addListener('click', addLatLng);
      }

      // Handles click events on a map, and adds a new point to the Polyline.
      function addLatLng(event) {
        var path = poly.getPath();

        // Because path is an MVCArray, we can simply append a new coordinate
        // and it will automatically appear.
        path.push(event.latLng);
        // console.log(computeLength(path));

        // Add a new marker at the new plotted point on the polyline.
        var marker = new google.maps.Marker({
          position: event.latLng,
          title: '#' + path.getLength(),
          map: map
        });
        latlang.push(marker.position.lat());
        latlang.push(marker.position.lng());
        position.push(marker.getPosition()); 
        console.log(position.toString());
      }

   
      function calcArea() {
        
        spherical = google.maps.geometry.spherical;
        // console.log(position.toString());
        area = spherical.computeArea(position);





        function practice(climateData) {

          document.getElementById("jan").innerHTML = climateData[0];
          document.getElementById("feb").innerHTML = climateData[1];
          document.getElementById("mar").innerHTML = climateData[2];
          document.getElementById("apr").innerHTML = climateData[3];
          document.getElementById("may").innerHTML = climateData[4];
          document.getElementById("jun").innerHTML = climateData[5];
          document.getElementById("jul").innerHTML = climateData[6];
          document.getElementById("aug").innerHTML = climateData[7];
          document.getElementById("sep").innerHTML = climateData[8];
          document.getElementById("oct").innerHTML = climateData[9];



          for(let i in climateData){
            // console.log(area);
            reportData.push(climateData[i] * area);
            // console.log(reportData.toFixed(2));
          }
          let totalVolume = 0;

          for(let i in reportData) {
             totalVolume = totalVolume + reportData[i];
          }

          document.getElementById("totalVolume").innerHTML = "Annual Volume = " + totalVolume.toFixed(3);
          document.getElementById("totalArea").innerHTML = "Total Area = " + area.toFixed(3);
          document.getElementById("waterConsumption").innerHTML = "Total Water Demand =" + waterDemand;
          document.getElementById("waterSupplied").innerHTML = "Total Water Supplied =" + (totalVolume/waterDemand * 100).toFixed(4) + "%";

          // console.log(reportData.toFixed(2));

          document.getElementById("vol1").innerHTML = reportData[0].toFixed(2);
          document.getElementById("vol2").innerHTML = reportData[1].toFixed(2);
          document.getElementById("vol3").innerHTML = reportData[2].toFixed(2);
          document.getElementById("vol4").innerHTML = reportData[3].toFixed(2);
          document.getElementById("vol5").innerHTML = reportData[4].toFixed(2);
          document.getElementById("vol6").innerHTML = reportData[5].toFixed(2);
          document.getElementById("vol7").innerHTML = reportData[6].toFixed(2);
          document.getElementById("vol8").innerHTML = reportData[7].toFixed(2);
          document.getElementById("vol9").innerHTML = reportData[8].toFixed(2);
          document.getElementById("vol10").innerHTML = reportData[9].toFixed(2);

        }

        // console.log("latlang="+latlang[0]);

        // console.log("the area is" + area + "square meter");
        if(latlang[0] <= 27.7090567 && latlang[0] >= 27.69025 && latlang[1] <= 85.4041 && latlang[1] >= 85.2836) {

          var waterDemand = 131400000000;


          document.getElementById("generalReport").innerHTML = "General Report of Kathmandu" ;
          document.getElementById("totalPopulation").innerHTML = "Total Population = 14,23,515";
          

          var climateData = [15, 15, 30, 55, 115, 255, 360, 315, 185, 60];

          practice(climateData);
        }

        else if (latlang[0] <= 28.27 && latlang[0] >= 28.166 && latlang[1] <= 84.1078 && latlang[1] >= 83.91) {

          document.getElementById("generalReport").innerHTML = "General Report of Pokhara"  ;


         var climateData = [25, 35, 60, 130, 360, 670, 940, 865, 640, 140];
         practice(climateData);
        }
        else if(latlang[0] <= 28.18 && latlang[0] >= 28.05 && latlang[1] <= 81.7001 && latlang[1] >= 81.58) {

            document.getElementById("generalReport").innerHTML = "General Report of Nepalgunj" ;

          climateData = [20, 25, 9, 8, 30, 155, 310, 325, 215, 40];
          practice(climateData);
        }
        else if(latlang[0] <= 27.456 && latlang[0] >= 27.42 && latlang[1] <= 85.029716 && latlang[1] >= 84.98) {

          document.getElementById("generalReport").innerHTML = "General Report of Hetauda" ;

          climateData = [12, 8, 22, 57, 105, 366, 613, 540, 378, 94];
          practice(climateData);
        }
  
 

        
        var chart = new CanvasJS.Chart("chartContainer", {
        animationEnabled: true,
        theme: "light2", // "light1", "light2", "dark1", "dark2"
        title:{
          text: " Total Rainfall in Selected Area"
        },
        axisY: {
          title: "volume of water in liter"
        },
        data: [{        
          type: "column",  
          showInLegend: true, 
          legendMarkerColor: "grey",
          dataPoints: [      
          { y: reportData[0], label: "January" },
          { y: reportData[1], label: "February" },
          { y: reportData[2], label: "March" },
          { y: reportData[3], label: "April" },
          { y: reportData[4], label: "May" },
          { y: reportData[5], label: "June" },
          { y: reportData[6], label: "July" },
          { y: reportData[7], label: "August" },
          { y: reportData[8], label: "September"},
          { y: reportData[9], label: "October"},
          ]
        }]
      });
      chart.render();
    }  

    </script>
    <script src="https://canvasjs.com/assets/script/canvasjs.min.js"> </script>
    <script async defer
    src="https://maps.googleapis.com/maps/api/js?key=AIzaSyBSYRhHtNd452qCjoYZIF_jrwbUV2Yipv8&callback=initMap&libraries=geometry" type="text/javascript">
    </script>
  